--- Changelog
-- 1.4 Adding Add/Delete Funktion for Consumes
-- 1.3 Hide Whisper / Improve imc menu
-- 1.2 Adding /imc whisper
-- 1.1 Adding /imc commands
-- 1.0 Checking Flask/Elixier and Food. Whisper Player and write in Raidchat

print("|cffff0000Invoke |cffffffffMissing Consumables Version: |cffAAAAAA1.3 |cffffffffloaded");
local f = CreateFrame("frame")
f:RegisterEvent( "READY_CHECK" )
f:RegisterEvent( "READY_CHECK_FINISHED" )
f:RegisterEvent( "CHAT_MSG_ADDON" )
imc_addonName = "<Invoke> Missing Consumables"



guardianExpireTime = 5
battleExpireTime = 5
flaskExpireTime = 5
foodExpireTime = 5
imc_readycheck = "activated"
imc_whisperpleps = "activated"
imc_hideWhisper = false

local missingFlask = "5"
local missingBattle = ""
local missingGuardian = ""
local missingFood = ""
		
--Checking Food with name cause tooo much SpellIDs
local IMC_FoodTable = {
    "Well Fed", -- Satt ENG
    "Enlightened", --Satt ENG
    "Satt", --GER
    "Erleuchtet" --GER
}
IMC_FlaskTable = { 
    28540, --reinen Todes
    28520, -- unerbittlichen Angriffs
    28519, -- wiederherstellung
    28518, --stärkung
    28521, --blendenden Lichts
    42735, --wiederstand
    17637, --classic oberste Macht   
	41609, --mark of illidari flask
	41610,
	41611,
	41608,
	46837,
	46839
}

IMC_BattleElixTable = {
	28503, --Schattenmacht
	28501, --Feuermacht
	38954, --Teufelsstärke
	33726, --Meisters
	28497, --Beweglichkeit
	28491, --Heilkraft
	28493, --Frostmacht
	28490, --Stärke
	33721, --Adepten
	33720 --Ansturms    
}

IMC_GuardianElixTable = {
	28514, --Schwächung
	28509, --Magierblut
	28502, --Verteidigung
	39627, --Weisheit
	39628, --Eisenhaut
	39625, --Seelenstärke
	39626, --Erdelixier 
	11371, --Gift of Artas

}
--SlashCmdList['IMC_SLASHCMD'] = function(msg)
--    DEFAULT_CHAT_FRAME:AddMessage(msg or 'nil')
--end
SLASH_IMC_SLASHCMD1 = '/imc'

function SlashCmdList.IMC_SLASHCMD(parameter)
	local _, _, arg1 = strfind(parameter, '^%s*(.-)%s*$')
	if arg1 == "" then
		print("|cffff0000INVOKE |cffAAAAAAMissing Consumables")
		print("|cffff0000/imc |cffffffffrun |cffAAAAAA- Posting Missing Consumables")
		print("|cffff0000/imc |cffffffffFlask  |cffff0000" .. flaskExpireTime .. " |cffAAAAAAmin ")
		print("|cffff0000/imc |cffffffffBattle  |cffff0000" .. battleExpireTime .. " |cffAAAAAAmin")
		print("|cffff0000/imc |cffffffffGuardian  |cffff0000" .. guardianExpireTime .. " |cffAAAAAAmin")
		print("|cffff0000/imc |cffffffffFood  |cffff0000" .. foodExpireTime .. " |cffAAAAAAmin")
		if imc_readycheck == "activated" then
			print("|cffff0000/imc |cffffffffreadycheck |cff00ff00" .. imc_readycheck .. "|cffAAAAAA - Post on readycheck")
		else
			print("|cffff0000/imc |cffffffffreadycheck |cffff0000" .. imc_readycheck .. "|cffAAAAAA - Post on readycheck")
		end
		if imc_whisperpleps == "activated" then
			print("|cffff0000/imc |cffffffffwhisper |cff00ff00" .. imc_whisperpleps .. "|cffAAAAAA - whisper on readycheck")
		else
			print("|cffff0000/imc |cffffffffwhisper |cffff0000" .. imc_whisperpleps .. "|cffAAAAAA - whisper on readycheck")
		end
		print("|cffff0000/imc |cffffffffAddFlask / AddGuardian / AddBattle  |cffff0000ID |cffAAAAAA - Add Consumable")
		print("|cffff0000/imc |cffffffffDeleteFlask / DeleteGuardian / DeleteBattle  |cffff0000ID |cffAAAAAA - Delete Consumable")
	else
		slash_print(arg1)
	end
end

function slash_print(arg1)
	if arg1 == "run" then
		--run script
		if IsInRaid() and not UnitAffectingCombat("player") then
			f.runCheck()
		end	
	elseif arg1 == "whisper" then
		--toogle
		if imc_whisperpleps == "activated" then
			imc_whisperpleps = "deactivated"
			print("|cffff0000imc |cffffffffwhisper |cffff0000deactivated")
		else
			imc_whisperpleps = "activated"
			print("|cffff0000imc |cffffffffwhisper |cff00ff00activated")			
		end			
	elseif arg1 == "readycheck" then	
		--toogle
		if imc_readycheck == "activated" then
			imc_readycheck = "deactivated"
			print("|cffff0000imc |cffffffffreadycheck |cffff0000deactivated")
		else
			imc_readycheck = "activated"
			print("|cffff0000imc |cffffffffreadycheck |cff00ff00activated")			
		end			
	else
		local text={}
		local count = 1
		for str in string.gmatch(arg1, "([^".. " " .."]+)") do
			text[count] = string.format("%s",str)
			count = count + 1
		end
		text[1] = string.lower(string.format(text[1]))
		if text[1] == "flask" then
			flaskExpireTime = tonumber(text[2])
			print("Flask Expire Time: " .. flaskExpireTime)
		elseif text[1] == "battle" then
			battleExpireTime = tonumber(text[2])
			print("Battle Elixier Expire Time: " .. battleExpireTime)
		elseif text[1] == "guardian" then
			guardianExpireTime = tonumber(text[2])
			print("Guardian Expire Time: " .. guardianExpireTime)
		elseif text[1] == "food" then
			foodExpireTime = tonumber(text[2])
			print("Food Expire Time: " .. foodExpireTime)
		elseif text[1] == "addflask" then			
			f:AddSpellIdToArray("flask",tonumber(text[2]))			
		elseif text[1] == "addguardian" then
			f:AddSpellIdToArray("guardian",tonumber(text[2]))
		elseif text[1] == "addbattle" then	
			f:AddSpellIdToArray("battle",tonumber(text[2]))
		elseif text[1] == "deleteflask" then			
			f:DeleteSpellIdToArray("flask",tonumber(text[2]))			
		elseif text[1] == "deleteguardian" then
			f:DeleteSpellIdToArray("guardian",tonumber(text[2]))
		elseif text[1] == "deletebattle" then	
			f:DeleteSpellIdToArray("battle",tonumber(text[2]))			
		end
	end

end

function f:DeleteSpellIdToArray(arrayname,id)
	local array = {}
	if arrayname == "flask" then array = IMC_FlaskTable
	elseif arrayname == "guardian" then array = IMC_GuardianElixTable
	elseif arrayname == "battle" then array = IMC_BattleElixTable end
	
	for i,v in pairs(array) do
		if v == id then
			table.remove(array,i)
		end
	end
	
	if arrayname == "flask" then IMC_FlaskTable = array
	elseif arrayname == "guardian" then IMC_GuardianElixTable = array
	elseif arrayname == "battle" then IMC_BattleElixTable = array end
 	print("|cffff0000imc |cff00ff00Deleting Successful")
	f:PrintArrayWithSpellName(arrayname)
end

function f:AddSpellIdToArray(arrayname,id)
	local name = GetSpellInfo(id)
	local consumeName = ""
	if name == nil then
		print("Invalid SpellID")
		return 0
	end		
	if arrayname == "flask" then 
		table.insert(IMC_FlaskTable,id)
		consumeName = "Flask"
	elseif arrayname == "guardian" then 
		table.insert(IMC_GuardianElixTable,id) 
		consumeName = "Guardian Elixier"
	elseif arrayname == "battle" then 
		table.insert(IMC_BattleElixTable,id)
		consumeName = "Battle Elixiser"
	end	
	print("|cffff0000imc |cff00ff00Add " .. consumeName .. ": " .. id .. "(" .. name .. ")")
	f:PrintArrayWithSpellName(arrayname)
end

function f:PrintArrayWithSpellName(arrayname)
	local array = {}
	if arrayname == "flask" then array = IMC_FlaskTable
	elseif arrayname == "guardian" then array = IMC_GuardianElixTable
	elseif arrayname == "battle" then array = IMC_BattleElixTable end
	local str = "List all IDs: "
	for i,v in pairs(array) do
		local name = GetSpellInfo(v)
		str = string.format("%s %s(%s)",str,tostring(v),name)
	end  
	print(str)
end

f:SetScript("OnEvent", function(self,event,arg1,arg2)
	if event == "READY_CHECK" and arg1 ~= nil and arg2 ~= nil and not UnitAffectingCombat("player") and imc_readycheck == "activated" then	
		imc_hideWhisper = true
		f.runCheck()		
    end
	if event == "READY_CHECK_FINISHED" then
		imc_hideWhisper = false
	end	
end)

function f.gotX(playername,missingX,xExpire,xExpireTime,text)		
	if xExpire == 0 then
		local rtxt = string.format("Missing %s!",text,xExpire)   
		if imc_whisperpleps == "activated" then
			SendChatMessage(rtxt,"WHISPER",nil,playername)
		end			
		missingX = string.format("%s %s",missingX,playername)
    elseif xExpire == -1 then
		-- no remaining Time cause not in Range - but got Food
    elseif xExpire < xExpireTime then    
        local rtxt = string.format("Missing %s! (%1.0fm)",text,xExpire)                        
        if imc_whisperpleps == "activated" then
			SendChatMessage(rtxt,"WHISPER",nil,playername)
		end			
        missingX = string.format("%s %s(%1.0fm)",missingX,playername,xExpire)
    else
        print("GotX Error")                        
    end 
	if text == "Food" then
		missingFood = missingX
	elseif text == "Flask" then
		missingFlask = missingX
	elseif text == "Guardian Elixier" then
		missingGuardian = missingX
	elseif text == "Battle Elixier" then
		missingBattle = missingX
	end
end
	
function f.runCheck()
	
	missingFlask = "Missing Flask:"
	missingBattle = "Missing Combat Elixier:"
	missingGuardian = "Missing Guardian Elixier:"
	missingFood = "Missing Food:"
    local skipFlask = true
    local skipBattle = true
    local skipGuardian = true
    local skipFood = true
       
    for i=1,GetNumGroupMembers() do 
        local playername,_,_,_,_,_,_,online=GetRaidRosterInfo(i) 
        if online then
            local raidN = string.format("raid%d",i) 
            local gotFlask = false
            local gotBattleElix = false
            local gotGuardianElix = false
            local gotFood = false
            local foodExpire = 0
            local flaskExpire = 0
            local guardianExpire = 0
            local battleExpire = 0
            for k=1,40 do 
                local actualBuff,_,_,_,_,expireTime,_,_,_,id = UnitBuff(raidN,k)
                    
                if actualBuff == nil then
                    break
                end
                --Check if ppl got Flask
                for j=1,table.getn(IMC_FlaskTable) do
                    if id == IMC_FlaskTable[j] then
                        flaskExpire = ((expireTime - GetTime())/60)
                        if expireTime == 0 then
							flaskExpire = -1
							gotFlask = true
						elseif flaskExpire > guardianExpireTime then							
							gotFlask = true
						end    
                        break
                    end 
                end
                --Check Pots Battle
                for j=1,table.getn(IMC_BattleElixTable) do
                    if id == IMC_BattleElixTable[j] then
                        battleExpire = ((expireTime - GetTime())/60)
                        if expireTime == 0 then
							battleExpire = -1
							gotBattleElix = true
						elseif battleExpire > guardianExpireTime then							
							gotBattleElix = true
						end         
                        break
                    end 
                end
                --Check Pots Guardian
                for j=1,table.getn(IMC_GuardianElixTable) do
                    if id == IMC_GuardianElixTable[j] then
                        guardianExpire = ((expireTime - GetTime())/60)
						if expireTime == 0 then
							guardianExpire = -1
							gotGuardianElix = true
						elseif guardianExpire > guardianExpireTime then							
							gotGuardianElix = true
						end 
                        break
                    end 
                end
                
                --Check Food
                for j=1,table.getn(IMC_FoodTable) do
                    if actualBuff == IMC_FoodTable[j] then
                        foodExpire = ((expireTime - GetTime())/60)
						if expireTime == 0 then
							foodExpire = -1
							gotFood = true
						elseif foodExpire > foodExpireTime then	
							gotFood = true
						end  
                        break
                    end 
                end
                if (gotFlask or (gotBattleElix and gotGuardianElix)) and gotFood then
                    break
                end                
            end
            if (gotFlask == false and (gotBattleElix == false and gotGuardianElix == false)) then
                f.gotX(playername,missingFlask,flaskExpire,flaskExpireTime,"Flask")
                skipFlask = false                    
            end
            if (gotFlask == false and gotBattleElix == false) and gotGuardianElix then
                f.gotX(playername,missingBattle,battleExpire,battleExpireTime,"Battle Elixier")
                skipBattle = false
            end
            if (gotFlask == false and gotGuardianElix == false) and gotBattleElix then
                f.gotX(playername,missingGuardian,guardianExpire,guardianExpireTime,"Guardian Elixier")
                skipGuardian = false
            end                
            if gotFood == false then
				f.gotX(playername,missingFood,foodExpire,foodExpireTime,"Food")
                skipFood = false
            end            
                
        end
    end
    SendChatMessage(imc_addonName,"RAID",nil)	
    if not skipFlask then 
        SendChatMessage(missingFlask,"RAID",nil)
    end
    if not skipBattle then            
        SendChatMessage(missingBattle,"RAID",nil)
    end               
    if not skipGuardian then
        SendChatMessage(missingGuardian,"RAID",nil)
    end
    if not skipFood then
        SendChatMessage(missingFood,"RAID",nil)
    end
    if skipFlask and skipBattle and skipGuardian and skipFood then
		SendChatMessage("No Missing Consumables.","RAID",nil)
	end	
end

local thingsToHide = {
    "Missing Flask",
    "Missing Battle Exlixier",
	"Missing Guardian Elixier",
	"Missing Food",
}

ChatFrame_AddMessageEventFilter("CHAT_MSG_WHISPER_INFORM", function(frame, event, message, sender, ...)
	if imc_hideWhisper == true then
		for i, v in ipairs(thingsToHide) do
			if message:match(v) then
				return true -- hide this message
			end
		end
	end		
end)

function f:CHAT_MSG_ADDON(event, prefix, message, distribution, source)
    if prefix == self.commPrefix and (distribution == "PARTY" or distribution == "RAID" or distribution == "INSTANCE_CHAT" or distribution == "WHISPER") and sender then
        self:ParseMessage(sender, message)
    end
end
